"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toFirehoseRecords = exports.fromFirehose = exports.UNKNOWN_FIREHOSE_EVENT_TYPE = void 0;
var _highland = _interopRequireDefault(require("highland"));
var _utils = require("../utils");
var _filters = require("../filters");
var _queries = require("../queries");
const fromFirehose = event => (0, _highland.default)(event.records).map(record => (
// create a unit-of-work for each event
// so we can correlate related work for error handling
{
  record,
  event: Buffer.from(record.data, 'base64').toString('utf8'),
  recordId: record.recordId,
  result: 'Dropped' // by default, set to 'Ok' in transform, 'ProcessingFailed' in fault processing ???
})).map((0, _utils.faulty)(uow => ({
  ...uow,
  event: JSON.parse(uow.event, _utils.decompress)
}))).filter(_filters.outSkip).through((0, _queries.redeemClaimcheck)());

// test helper
exports.fromFirehose = fromFirehose;
const toFirehoseRecords = (events, approximateArrivalTimestamp) => ({
  invocationId: 'invocationIdExample',
  deliveryStreamArn: 'arn:aws:kinesis:TEST',
  region: process.env.AWS_REGION || /* istanbul ignore next */'us-west-2',
  records: events.map((e, i) => ({
    recordId: `${i}`,
    // "49546986683135544286507457936321625675700192471156785154",
    data: Buffer.from(JSON.stringify(e, (0, _utils.compress)())).toString('base64'),
    approximateArrivalTimestamp // format: 1495072949453
  }))
});
exports.toFirehoseRecords = toFirehoseRecords;
const UNKNOWN_FIREHOSE_EVENT_TYPE = exports.UNKNOWN_FIREHOSE_EVENT_TYPE = toFirehoseRecords([{
  type: 'unknown-type'
}]);